From 9ed15c6f692d4fc471e128499d8247c1b144242e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 01:02:03 +0000
Subject: [PATCH 1122/2232] Add static assertions for Str trivial operations


---

diff --git a/src/cxx.cc b/src/cxx.cc
index d423ab7..08ad3ce 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -5,6 +5,7 @@
 #include <iostream>
 #include <memory>
 #include <stdexcept>
+#include <type_traits>
 #include <vector>
 
 extern "C" {
@@ -154,6 +155,12 @@ std::ostream &operator<<(std::ostream &os, const Str &s) {
   return os;
 }
 
+static_assert(std::is_trivially_copy_constructible<Str>::value,
+              "trivial Str(const Str &)");
+static_assert(std::is_trivially_copy_assignable<Str>::value,
+              "trivial operator=(const Str &)");
+static_assert(std::is_trivially_destructible<Str>::value, "trivial ~Str()");
+
 extern "C" {
 const char *cxxbridge05$error(const char *ptr, size_t len) {
   char *copy = new char[len];

